/// <reference types="node" />
import Transformer from './Transformer';
export declare class Source {
    readonly path: string;
    readonly content: string;
    constructor(path: string, content: string);
}
export declare class SourceTransformResult {
    readonly source: Source;
    readonly output: string | null;
    readonly error: Error | null;
    constructor(source: Source, output: string | null, error: Error | null);
}
export default class TransformRunner {
    readonly sources: IterableIterator<Source> | Array<Source>;
    readonly transformer: Transformer;
    constructor(sources: IterableIterator<Source> | Array<Source>, transformer: Transformer);
    run(): AsyncIterableIterator<SourceTransformResult>;
}
