"use strict";
var __await = (this && this.__await) || function (v) { return this instanceof __await ? (this.v = v, this) : new __await(v); }
var __asyncGenerator = (this && this.__asyncGenerator) || function (thisArg, _arguments, generator) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var g = generator.apply(thisArg, _arguments || []), i, q = [];
    return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
    function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
    function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
    function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
    function fulfill(value) { resume("next", value); }
    function reject(value) { resume("throw", value); }
    function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
};
Object.defineProperty(exports, "__esModule", { value: true });
class Source {
    constructor(path, content) {
        this.path = path;
        this.content = content;
    }
}
exports.Source = Source;
class SourceTransformResult {
    constructor(source, output, error) {
        this.source = source;
        this.output = output;
        this.error = error;
    }
}
exports.SourceTransformResult = SourceTransformResult;
class TransformRunner {
    constructor(sources, transformer) {
        this.sources = sources;
        this.transformer = transformer;
    }
    run() {
        return __asyncGenerator(this, arguments, function* run_1() {
            for (let source of this.sources) {
                let transformed;
                try {
                    let output = yield __await(this.transformer.transform(source.path, source.content));
                    transformed = new SourceTransformResult(source, output, null);
                }
                catch (err) {
                    transformed = new SourceTransformResult(source, null, err);
                }
                yield yield __await(transformed);
            }
        });
    }
}
exports.default = TransformRunner;
//# sourceMappingURL=TransformRunner.js.map